; spiffGRILL/theme.jl

;; Copyleft (C) 1999 Garrett LeSage
;; Based off of my spiffE Enlightenment theme....

;; Ported to sawmill 0.16- by Garrett LeSage
;; Ported to sawmill 0.17 by David Chan (adraken)

;; 
;; Based on spiffMILL by garrett..
;; further whacked on by Tuomas Kuosmanen <tigert@gimp.org>
;;

(let*
  (
    (font (get-font "-*-lucida-medium-r-normal-*-*-100-*-*-p-*-iso8859-1"))
    (font-colors (list "grey" "white"))
    
	(title-images (list (make-image "bar_unfocused_horizontal_normal.png")
                            (make-image "bar_focused_horizontal_normal.png")))

     	(iconify-images (list (make-image "iconify-normal.png")
			      nil nil
                              (make-image "iconify-clicked.png")))

     	(maximize-images (list (make-image "maximize-normal.png")
                               nil nil
  	 		       (make-image "maximize-clicked.png")))

     	(close-images (list (make-image "close-normal.png")
			    nil nil
                            (make-image "close-clicked.png")))

     	(border-top (make-image "border_top.xpm"))
     	(border-bottom (make-image "border_bottom.xpm"))
     	(border-right (make-image "border_right.xpm"))
     	(border-left (make-image "border_left.xpm"))

     	(corner-tl (make-image "corner_top_left.xpm"))
     	(corner-tr (make-image "corner_top_right.xpm"))
     	(corner-bl (make-image "corner_bottom_left.xpm"))
     	(corner-br (make-image "corner_bottom_right.xpm"))

     	(frame `(
		((background . ,title-images)
		 (top-edge . -12)
		 (left-edge . 0)
		 (class . iconify-button))

		((background . ,title-images)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
		 (x-justify . 4)
		 (y-justify . center)
		 (top-edge . -12)
		 (left-edge . 12)
		 (right-edge . 0)
		 (class . title))

		((background . ,iconify-images)
      		 (top-edge . -11)
		 (left-edge . 1) 
		 (class . iconify-button))

     		((background . ,maximize-images)
      		 (top-edge . -11)
      		 (right-edge . 13)
      		 (class . maximize-button))

    		((background . ,close-images)
      		 (top-edge . -11)
      		 (right-edge . 1)
      		 (class . close-button))

     		((background . ,border-left)
      		 (top-edge . -12)
      		 (bottom-edge . 0)
      		 (left-edge . -2) 
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . -12)
      		 (bottom-edge . 0)
      		 (right-edge . -2)
      		 (class . right-border))

	     	((background . ,border-top)
      		 (top-edge . -14)
      		 (right-edge . 0)
      		 (left-edge . 0) 
      		 (class . top-border))

     		((background . ,border-bottom)
      		 (bottom-edge . -2)
      		 (right-edge . 0)  
      		 (left-edge . 0)   
      		 (class . bottom-border))

     		((background . ,corner-tl)
      		 (top-edge . -14)
      		 (left-edge . -2)
      		 (class . top-left-corner))

     		((background . ,corner-tr)
      		 (top-edge . -14)
      		 (right-edge . -2)
      		 (class . top-right-corner))

     		((background . ,corner-bl)
      		 (bottom-edge . -2)
      		 (left-edge . -2)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br)
      		 (bottom-edge . -2)
      		 (right-edge . -2) 
      		 (class . bottom-right-corner))
	))

	(shaped-frame `(
     		((background . ,title-images)
      		 (top-edge . -12)
      		 (left-edge . 0) 
      		 (class . iconify-button))
      
     		((background . ,title-images)
      		 (foreground . ,font-colors)
      		 (font . ,font)
      		 (text . ,window-name)
      		 (x-justify . 4)
      		 (y-justify . center)
      		 (top-edge . -12)
      		 (left-edge . 12)
      		 (right-edge . 0)
      		 (class . title))

     		((background . ,iconify-images)
      		 (top-edge . -11)
      		 (left-edge . 1) 
      		 (class . iconify-button))

     		((background . ,maximize-images)
      		 (top-edge . -11)
      		 (right-edge . 13)
      		 (class . maximize-button))

     		((background . ,close-images)
      		 (top-edge . -11)
      		 (right-edge . 1)
      		 (class . close-button))

     		((background . ,border-left)
      		 (top-edge . -12)
      		 ;;(bottom-edge . 0)
      		 (left-edge . -2)   
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . -12)
      		 ;;(bottom-edge . 0)
      		 (right-edge . -2)  
      		 (class . right-border))

     		((background . ,border-top)
      		 (top-edge . -14)
      		 (right-edge . 0)
      		 (left-edge . 0) 
      		 (class . top-border))

     		((background . ,border-bottom)
      		 (top-edge . 0)
      		 (right-edge . 0)
      		 (left-edge . 0) 
      		 (class . bottom-border))

         	((background . ,corner-tl)
      		 (top-edge . -14)
      		 (left-edge . -2)
      		 (class . top-left-corner))

     		((background . ,corner-tr)
      		 (top-edge . -14)
      		 (right-edge . -2)
      		 (class . top-right-corner))

     		((background . ,corner-bl)
      		 (top-edge . 0)
      		 (left-edge . -2)
      		 (class . bottom-left-corner))

     		((background . ,corner-br)
      		 (top-edge . 0)
      		 (right-edge . -2)
      		 (class . bottom-right-corner))
	))

	(transient-frame `(
		((background . ,title-images)
		 (top-edge . -12)
		 (left-edge . 0)
		 (class . iconify-button))

		((background . ,title-images)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
		 (x-justify . 4)
		 (y-justify . center)
		 (top-edge . -12)
		 (left-edge . 12)
		 (right-edge . 0)
		 (class . title))

		((background . ,iconify-images)
      		 (top-edge . -11)
		 (left-edge . 1) 
		 (class . iconify-button))

    		((background . ,close-images)
      		 (top-edge . -11)
      		 (right-edge . 1)
      		 (class . close-button))

     		((background . ,border-left)
      		 (top-edge . -12)
      		 (bottom-edge . 0)
      		 (left-edge . -2) 
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . -12)
      		 (bottom-edge . 0)
      		 (right-edge . -2)
      		 (class . right-border))

	     	((background . ,border-top)
      		 (top-edge . -14)
      		 (right-edge . 0)
      		 (left-edge . 0) 
      		 (class . top-border))

     		((background . ,border-bottom)
      		 (bottom-edge . -2)
      		 (right-edge . 0)  
      		 (left-edge . 0)   
      		 (class . bottom-border))

     		((background . ,corner-tl)
      		 (top-edge . -14)
      		 (left-edge . -2)
      		 (class . top-left-corner))

     		((background . ,corner-tr)
      		 (top-edge . -14)
      		 (right-edge . -2)
      		 (class . top-right-corner))

     		((background . ,corner-bl)
      		 (bottom-edge . -2)
      		 (left-edge . -2)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br)
      		 (bottom-edge . -2)
      		 (right-edge . -2) 
      		 (class . bottom-right-corner))
	))
	
	(shaped-transient-frame `(
     		((background . ,title-images)
      		 (top-edge . -12)
      		 (left-edge . 0) 
      		 (class . iconify-button))
      
     		((background . ,title-images)
      		 (foreground . ,font-colors)
      		 (font . ,font)
      		 (text . ,window-name)
      		 (x-justify . 4)
      		 (y-justify . center)
      		 (top-edge . -12)
      		 (left-edge . 12)
      		 (right-edge . 0)
      		 (class . title))

     		((background . ,iconify-images)
      		 (top-edge . -11)
      		 (left-edge . 1) 
      		 (class . iconify-button))

     		((background . ,close-images)
      		 (top-edge . -11)
      		 (right-edge . 1)
      		 (class . close-button))

     		((background . ,border-left)
      		 (top-edge . -12)
      		 ;;(bottom-edge . 0)
      		 (left-edge . -2)   
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . -12)
      		 ;;(bottom-edge . 0)
      		 (right-edge . -2)  
      		 (class . right-border))

     		((background . ,border-top)
      		 (top-edge . -14)
      		 (right-edge . 0)
      		 (left-edge . 0) 
      		 (class . top-border))

     		((background . ,border-bottom)
      		 (top-edge . 0)
      		 (right-edge . 0)
      		 (left-edge . 0) 
      		 (class . bottom-border))

         	((background . ,corner-tl)
      		 (top-edge . -14)
      		 (left-edge . -2)
      		 (class . top-left-corner))

     		((background . ,corner-tr)
      		 (top-edge . -14)
      		 (right-edge . -2)
      		 (class . top-right-corner))

     		((background . ,corner-bl)
      		 (top-edge . 0)
      		 (left-edge . -2)
      		 (class . bottom-left-corner))

     		((background . ,corner-br)
      		 (top-edge . 0)
      		 (right-edge . -2)
      		 (class . bottom-right-corner))
	))
	
  )
  (add-frame-style 'spiffGRILL
    	(lambda (w type)   
          (cond 
	      ((eq type 'shaped) shaped-frame)
              ((eq type 'transient) transient-frame)
              ((eq type 'shaped-transient) shaped-transient-frame)
              ((eq type 'unframed) nil-frame)
              (t frame)))))
